local game = require(".game")
local menu = require("menu")

local STATE = {
    mode = "menu",
    lives = {"pong", "asteroid", "invaders", "flappy"}
}

menu.init_state(STATE)
game.init_state(STATE)

function render()
    if STATE.mode == "menu" then
        menu.render(STATE)
    else
        game.render(STATE)
    end
end

function update()
    local new_mode = STATE.mode
    if STATE.mode == "menu" then
        new_mode = menu.update(STATE) or new_mode
    else
        new_mode = game.update(STATE) or new_mode
    end
    if new_mode ~= STATE.mode then
        game.reset(STATE)
        menu.reset(STATE)
        buttons.read()
    end
    STATE.mode = new_mode
end

function main()
    buttons.analogtodpad(55) -- My PSP has really bad joystick drift...
    buttons.interval() -- no autorepeat
    while true do
        buttons.read()
        local skip_render = update()
        if not skip_render then
            render()
            screen.flip()
        end
    end
end

main()
